package javax.imageio.spi;

import java.io.IOException;
import javax.imageio.ImageWriter;
import java.awt.image.RenderedImage;
import javax.imageio.ImageTypeSpecifier;
import javax.imageio.stream.ImageOutputStream;

public abstract class ImageWriterSpi extends ImageReaderWriterSpi
{
    @Deprecated
    public static final Class[] STANDARD_OUTPUT_TYPE;
    protected Class[] outputTypes;
    protected String[] readerSpiNames;
    private Class writerClass;
    
    protected ImageWriterSpi() {
        this.outputTypes = null;
        this.readerSpiNames = null;
        this.writerClass = null;
    }
    
    public ImageWriterSpi(String s, String s2, String[] array, String[] array2, String[] array3, String s3, Class[] array4, String[] array5, boolean b, String s4, String s5, String[] array6, String[] array7, boolean b2, String s6, String s7, String[] array8, String[] array9) {
        super(s, s2, array, array2, array3, s3, b, s4, s5, array6, array7, b2, s6, s7, array8, array9);
        this.outputTypes = null;
        this.readerSpiNames = null;
        this.writerClass = null;
        if (array4 == null) {
            throw new IllegalArgumentException("outputTypes == null!");
        }
        if (array4.length == 0) {
            throw new IllegalArgumentException("outputTypes.length == 0!");
        }
        this.outputTypes = ((array4 == ImageWriterSpi.STANDARD_OUTPUT_TYPE) ? new Class[] { ImageOutputStream.class } : ((Class[])array4.clone()));
        if (array5 != null && array5.length > 0) {
            this.readerSpiNames = (String[])(String[])array5.clone();
        }
        return;
    }
    
    public boolean isFormatLossless() {
        return true;
    }
    
    public Class[] getOutputTypes() {
        return (Class[])(Class[])this.outputTypes.clone();
    }
    
    public abstract boolean canEncodeImage(ImageTypeSpecifier p0);
    
    public boolean canEncodeImage(RenderedImage image) {
        return this.canEncodeImage(ImageTypeSpecifier.createFromRenderedImage(image));
    }
    
    public ImageWriter createWriterInstance() throws IOException {
        return this.createWriterInstance(null);
    }
    
    public abstract ImageWriter createWriterInstance(Object p0) throws IOException;
    
    public boolean isOwnWriter(ImageWriter imageWriter) {
        if (imageWriter == null) {
            throw new IllegalArgumentException("writer == null!");
        }
        return imageWriter.getClass().getName().equals(this.pluginClassName);
    }
    
    public String[] getImageReaderSpiNames() {
        return (this.readerSpiNames == null) ? null : ((String[])(String[])this.readerSpiNames.clone());
    }
    
    static {
        STANDARD_OUTPUT_TYPE = new Class[] { ImageOutputStream.class };
    }
}
